#!/usr/bin/perl

# Intermediate Search, Version 1.1
#	Copyright 1997 by Fluid Dynamics <xav.com>
#	Dieses Script darf frei verwendet werden, aber bitte vor der 
#	Weiterverteilung fragen.
#	Deutsche Uebersetzung Gerold Bigorajski
#	http://www.gb-direkt.de
#
# Neueste Versionen und Hilfedateien unter:
#	http://www.xav.com/scripts/search/
#
# Im Gegensatz zum englischen Original wurde die Sucheingabe auf ein permanentes
# HTML-Dokument ausgelagert, um die Ladezeit pro Dokument in Grenzen zu halten.
# __________________________________________________________________

# Das absolute Grundverzeichnis saemtlicher Dateien.
# Mit abschliessendem Schraegstrich.
$basedir = '/home/strato/www/gb/www.gb-direkt.de/htdocs/';

# Die URL des Grundverzeichnisses.
$baseurl = 'http://www.gb-direkt.de/';

# Diese Dateien werden aufgelistet. Das Sternchen dient
# als Jokerzeichen fr alle Dateien und Verzeichnisse.
@files = ('*.htm',
	'business/*.htm',
	'business/*/*.htm',
	'edv/*.htm',
	'suche/*.htm',
	'gastbuch/*/*.htm',
	'goodies/*.htm',
	'kunst/*.htm',
	'kunst/*/*.htm',
	'kunst/*/*/*.htm',
	'layout/*.htm',
	'marketng/*.htm',
	'news/*.htm',
	'kontakt/*.htm',
	'spiele/*.htm',
	'spiele/*/*.htm',
	'secure/*.htm',
	'komm/*.htm',
	'komm/*/*.htm',
	'komm/*/*/*.htm',
	'navitree/*.htm',
	'translat/*.htm',
	'award/*.htm');

# Diese Datei muss schreib- und ausfuehrbar gemacht werden (chmod 777 summary.htm)
# und sollte gut versteckt plaziert sein!
# Sie enthaelt die Ergenisse jeglicher Suche, so dass Sie wissen, wonach die Leute
# wirklich Ausschau halten, wenn Sie Ihre Site besuchen. 
# Moeglichkeiten sind, die Datei in einem Non-Web- oder einem versteckten oder
# sicheren Verzeichnis zu speichern. Daher ist hier der absolute Serverpfad notwendig.
$summary_file = '/home/strato/www/gb/www.gb-direkt.de/htdocs/_private/summaries.txt';

# Die URL und der Titel der Hauptseite Ihres Webs.
$link_url   = 'http://www.gb-direkt.de/startpag.shtm';
$link_title = 'Homepage';

# Die URL der Sucheingabe.
$searchhtm_url   = 'http://www.gb-direkt.de/suche/imsearch.htm';

# Die URL des Suchflugzeugs.
$searchpict = 'http://www.gb-direkt.de/images/plane.gif';

# Die URL des Hintergrundbildes
$backpicture = 'http://www.gb-direkt.de/images/sumtextb.jpg';

# Die URL des Trennbilds
$divideurl  = 'http://www.gb-direkt.de/images/sumhorsa.gif';
# Wenn hierfuer nichts eingegeben ist, wird eine horizontale Linie <hr> eingesetzt
if($divideurl eq "")
{
	$divideimg = "<hr>\n";
}
else
{
	$divideimg = "<p align=\"center\"><img src=\"$divideurl\" width=\"300\" height=\"10\"></p>\n";
}	

# Die folgende Zeile sollte nur dann zur vollstaendigen URL ergaenzt werden, wenn das Script umbenannt wird.
$cgi_url = 'http://www.gb-direkt.de/cgi-bin/gb-direkt/suche/search.cgi';

# Das folgende Array enthaelt die Informationen ueber alle Verzeichnisse und Dateitypen, 
# deren Durchsuchen Sie Ihren Besuchern erlauben wollen. Die Liesmich-Datei enthaelt
# weitere Informationen bzgl. individueller Einstellungsmoeglichkeiten.

# Optionen fuer gewichtete Suche:
#
# Jedes Vorkommen eines Suchbegriffs zaehlt als ein Punkt.
# Das Vorkommen eines Suchbegriffs im Dateinamen, Titel, META-keywords
# oder META-description kann gewichtet gezaehlt werden (Faktor 2, 3, 4 ...
# pro Treffer. Geben Sie die Multiplikatoren in das Array unten ein -
# die Standardwerte sind (2, 2, 4, 2). Wenn Sie dies nicht verstehen,
# storen Sie sich nicht weiter daran und belassen die Werte einfach auf
# den Vorgaben - sie funktionieren ziemlich gut.
# Bitte beachten Sie, dass dies den Seiten zusaetzliches Gewicht verleiht,
# die korrekt formatierte Titel und META-Tags haben - selbst wenn der 
# Dateiinhalt derselbe ist. 
($name_x, $title_x, $keywords_x, $description_x) = (2,2,4,2);


# Es ist kein weiteres Editieren notwendig, aber nur immer zu ...
# Der Hauptteil des folgenden Codes ist einfach HTML. Wenn Sie sich
# in grundlegender HTML-Programmierung auskennen, ist er sehr leicht
# zu modifizieren. 
# Als letzte Anmerkung: Wenn im HTML-Code Zeichen erforderlich sind, die
# auch als PERL-Steuerzeichen verwendet werden (", #, @,;,\,...), so muss Ihnen
# ein Backslash vorangestellt werden, also z.B. 
# <font color=\"\#123456\">
# __________________________________________________________________

# Lesen der Formulareingabe und Aufsplitten der Name-/Werte-Paare
# Ausserdem Konvertierung von MIME urlencoded in normal lesbare Zeichen
read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
@pairs = split(/&/,$buffer);
foreach $pair (@pairs)
{
	($name,$value) = split(/=/,$pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
}



if ($FORM{'terms'})
{
	&get_files;
	&search;
	&return_html;
}
else
{
	# Wenn im Eingabefeld der Suchausgabe keine Eingabe erfolgt,
	# geht es zurck zur ursprnglichen Suchseite.
	print "Location: $searchhtm_url\n\n";
}

# Dateien einlesen
sub get_files
{
	&bad_base unless (-e $basedir);
	chdir($basedir);
	foreach $file (@files)
	{
		$ls = `ls $file`;
		@ls = split(/\s+/,$ls);
		foreach $temp_file (@ls)
		{
			if (-d $file)
			{
				$filename = "$file$temp_file";
				if (-T $filename)
				{
					push(@FILES,$filename);
				}
			}
			elsif (-T $temp_file)
			{
				push(@FILES,$temp_file);
			}
		}
	}
}


# Stringaufbereitung und Suchroutine
sub search
{
	# Mehrfache in einfache Leerzeichen umsetzen:
	$FORM{'terms'} =~ s/\s+/ /g;
	$FORM{'terms'} = " $FORM{'terms'} ";

	# NOT in Minuszeichen umsetzen:
	$FORM{'terms'} =~ s/ not / -/ig;

	# AND in Pluszeichen umsetzen:
	$FORM{'terms'} =~ s/ and / \+/ig;

	# OR entfernen (OR ist der Standardwert):
	$FORM{'terms'} =~ s/ or / /ig;

	# Jokerzeichen entfernen (Uebel, uebel, sprach der Duebel!)
	$check = 'true' unless ($FORM{'terms'} =~ /\*/);

	# Eintraege in Anfuehrungsstrichen beruecksichtigen:
	@terms = split(/\"/,$FORM{'terms'});
	$iterator = 0;
	$FORM{'terms'} = "";
	$placeholder = '%%%==%%%';
	foreach $term (@terms)
	{
		# ein bisschen binaeres Hin- und herschieben:
		if ($iterator == 1)
			{$iterator--;}
		else
			{$iterator++;}

		# Die Laufvariable ist 0 waehrend Eingaben in Anfuehrungsstrichen:
		$term =~ s/ /$placeholder/g unless $iterator;
		$FORM{'terms'} .= $term;
	}
	# Korrektur gruppierter Eintraege ist erledigt - nun haben alle Abfragen mit 
	# "begriff1 begriff2" den haesslichen Platzhalter statt des Leerzeichens, so 
	# dass sie beim letztendlichen Splitting nicht aufgebrochen werden.

	@terms = split(/\s+/,$FORM{'terms'});
	foreach $term (@terms)
	{
		# Null-Eingaben auslassen (erster und letzter)
		next if ($term eq '');

		# Begriffe in Anfuehrungsstrichen demaskieren:
		$term =~ s/$placeholder/ /g;

		if ($term =~ /^\+/)
		{
			$term =~ s/\+//o;
			$term = '\W' . $term. '\W' unless ($term =~ /^\$/);
			$term =~ s/^\$//;
			push(@required,$term);
			$required_terms_present = "you bet";
		}
		elsif ($term =~ /^-/)
		{
			$term =~ s/-//o;
			$term = '\W' . $term. '\W' unless ($term =~ /^\$/);
			$term =~ s/^\$//;
			push(@forbidden,$term);
			$forbidden_terms_present = "fraid so";
		}
		else
		{
			$term = '\W' . $term. '\W' unless ($term =~ /^\$/);
			$term =~ s/^\$//;
			push(@optional,$term);
		}
	}


	# Aktuelle Suche
	foreach $FILE (@FILES)
	{
		open(FILE,"$FILE");
		@LINES = <FILE>;
		close(FILE);
		$string = join(' ',@LINES);
		$string =~ s/\n//g;


		# Titel extrahieren (falls vorhanden):
		if ($string =~ /<title>(.*)<\/title>/i)
		{
			# Wichtung
			$titles{$FILE} = $1;
			for ($i=1;$i<$title_x;$i++)
			{
				$string .= $titles{$FILE};
			}
		}
		$titles{$FILE} = $FILE unless $titles{$FILE};

		# Beschreibung extrahieren (falls vorhanden):
		if ($string =~ /<meta\s+name="description"\s+content="(.*)>/i)
		{
			@cut = split(/\">/,$1);
			$description{$FILE} = $cut[0];
			# Wichtung
			for ($i=0;$i<$description_x;$i++)
			{
				$string .= $description{$FILE};
			}
		}
		else
		{
			# Kein description-META-Tag -> die ersten 25 Woerter der Datei werden ausgegeben.
			$string2 = $string;
			$string2 =~ s/<title>(.*)<\/title>//ig;
			$string2 =~ s/<([^>]|\n)*>//g;
			@words = split(/\s+/,$string2);
			for ($i=0;$i<25;$i++)
			{
				$description{$FILE} .= "$words[$i] ";
			}
			$description{$FILE} .= "...";
		}


		# Schluesselworte extrahieren (falls vorhanden):
		if ($string =~ /<meta\s+name="keywords"\s+content="(.*)>/i)
		{
			@cut = split(/\">/,$1);
			$keywords{$FILE} = $cut[0];
			# Wichtung
			for ($i=0;$i<$keywords_x;$i++)
			{
				$string .= $keywords{$FILE};
			}
		}


		# Gewichtung des Dateinamens wie erforderlich:
 		for ($i=0;$i<$name_x;$i++)
		{
			$string .= "$baseurl$FILE";
		}


		# Die speziellen HTML-Tags sind erledigt. Aus der uebrigen Datei werden die
		# HTML-Tags entfernt, so dass sie in der Suche nicht verwendet werden:

		$string =~ s/<([^>]|\n)*>//g;


		# Ueberpruefen auf ODER-Ausdruecke:
		foreach $term (@optional)
		{
			$lowercase = $term;
			$lowercase =~ tr/[A-Z]/[a-z]/;
			$lowercase =~ tr/\\w/\\W/;

			if (($term eq $lowercase) && ($check))
			{
				$include{$FILE} = 'yes' if ($string =~ /$term/i);
				@count = split(/$term/i,$string);
			}
			elsif ($check)
			{
				$include{$FILE} = 'yes' if ($string =~ /$term/);
				@count = split(/$term/,$string);
			}
			$word_count = @count;
			$relevance{$FILE} = $relevance{$FILE} + $word_count;
		}
		# Ueberpruefen auf ODER-Ausdruecke erledigt.


		# Ueberpruefen auf UND-Ausdruecke:

		if ($required_terms_present eq "you bet")
		{
			foreach $term (@required)
			{
				$lowercase = $term;
				$lowercase =~ tr/[A-Z]/[a-z]/;
				$lowercase =~ tr/\\w/\\W/;
				if (($term eq $lowercase) && ($check))
				{
					if (($string =~ /$term/i) && ($include{$FILE} ne 'no'))
					{
						$include{$FILE} = 'yes';
						@count = split(/$term/i,$string);
					}
					else
					{
						$include{$FILE} = 'no';
						last;
					}
				}
				elsif ($check)
				{
					if (($string =~ /$term/) && ($include{$FILE} ne 'no'))
					{
						$include{$FILE} = 'yes';
						@count = split(/$term/,$string);
					}
					else
					{
						$include{$FILE} = 'no';
						last;
					}
				}
				$word_count = @count;
				$relevance{$FILE} = $relevance{$FILE} + $word_count;
			}
		}
		# Ueberpruefen auf UND-Ausdruecke erledigt.


		# Ueberpruefen auf NOT-Ausdruecke:
		if (($forbidden_terms_present eq "fraid so") && ($check))
		{
			foreach $term (@forbidden)
			{
				$lowercase = $term;
				$lowercase =~ tr/[A-Z]/[a-z]/;
				$lowercase =~ tr/\\w/\\W/;
				if (($term eq $lowercase) && ($string =~ /$term/i))
				{
					$include{$FILE} = 'no';
					last;
				}
				elsif ($string =~ /$term/)
				{
					$include{$FILE} = 'no';
					last;
				}
			}
		}
		# Ueberpruefen auf NOT-Ausdruecke erledigt.


		# Jokerzeichen-getriggerte Auflistung erlauben:
		$include{$FILE} = 'yes' unless ($check);


		# Format bzgl. Wichtung:
		if ($include{$FILE} eq 'yes')
		{
			$relevance = sprintf("%.3f",($relevance{$FILE}/1000));
			$HITS{"$relevance$FILE"} = "$FILE";
			$hitcount++;
		}


	} # Ende der Schleife durch alle Dateien.
} # Ende der Suchprozedur.

      
# Rueckgabe der Suchergebnisse
sub return_html
{
	# Als erstes wird eine zusammenfassende Datei fuer den Webmaster zu dem Besucher erstellt:
	# Ueberschrift abhaengig von der Anzahl der Treffer
	$docstring = "$hitcount Dokumente";
	$docstring = "Ein Dokument" if ($hitcount == 1);
	$docstring = "Keine Dokumente" unless ($hitcount);

	$doctitle  = "Erfolgreiche Suche" if ($hitcount > 0);
	$doctitle  = "Erfolglose Suche" unless ($hitcount);

	# Kopf als kleine Tabelle mit Hyperlinks
	$summary = "<font face=\"verdana, arial, helvetica\"><table border=\"0\" width=\"100\%\">\n";
	$summary .= "  <tr>\n";
	$summary .= "    <td width=\"34\%\"><h2><font color=\"\#003366\">$doctitle</font></h2><td>\n";
	$summary .= "    <td valign=\"top\" width=\"33\%\" align=\"center\"><a href=\"$searchhtm_url\#tips\" target=\"_self\">Abfragesyntax</a></td>\n";
	$summary .= "    <td valign=\"top\" width=\"33\%\" align=\"right\"><a href=\"$baseurl \" target=\"_self\">Zur Homepage</a></td>\n";
	$summary .= "  </tr>\n";
	$summary .= "</table>\n";
	$summary .= "<blockquote>\n";
	$summary .= "  <h3><font color=\"\#003366\">$docstring gefunden</font></h3>\n";

	# ODER-Begriffe auflisten
	$summary .= "    <pre>Mit <b><font color=\"\#008000\">ODER</font></b> verknpfte Begriffe:\n" if (@optional);
	$i = 0;
	foreach $term (@optional)
	{
		$term = "<font color=\"\#800000\"><I><STRONG>$term</STRONG></I></font>" unless ($term =~ /^\\W/);
		$term =~ s/\\W//g;
		$summary .= "$term";
		$i++;
		$summary .= ", " unless ($i == @optional);
	}

	# AND-Begriffe auflisten
	$summary .= "    <pre>Mit <b><font color=\"\#008000\">UND</font></b> verknpfte Begriffe:\n" if (@required);
	$i = 0;
	foreach $term (@required)
	{
		$term = "<font color=\"\#800000\"><I><STRONG>$term</STRONG></I></font>" unless ($term =~ /^\\W/);
		$term =~ s/\\W//g;
		$summary .= "$term";
		$i++;
		$summary .= ", " unless ($i == @required);
	}

	# NOT-Begriffe auflisten
	$summary .= "    <pre>Mit <b><font color=\"\#008000\">NOT</font></b> verknpfte Begriffe:\n" if (@forbidden);
	$i = 0;
	foreach $term (@forbidden)
	{
		$term = "<font color=\"\#800000\"><I><STRONG>$term</STRONG></I></font>" unless ($term =~ /^\\W/);
		$term =~ s/\\W//g;
		$summary .= "$term";
		$i++;
		$summary .= ", " unless ($i == @forbidden);
	}
	$summary .= "\n</BLOCKQUOTE>\n";

	# Ausgabe in eine permanente Textdatei
	open(SUMMARY,">>$summary_file");
	print SUMMARY "\n\n";
	if ($ENV{'REMOTE_HOST'})
	{
		print SUMMARY "Suche durch $ENV{'REMOTE_HOST'}:\n";
	}
	elsif ($ENV{'REMOTE_ADDR'})
	{
		print SUMMARY "Suche durch $ENV{'REMOTE_ADDR'}:\n";
	}
	else
	{
		print SUMMARY "Suche durch Unbekannten\n";
	}
	print SUMMARY "Suchbegriff\n	ODER\:	";
	foreach $term (@optional)
	{
		print SUMMARY "$term, ";
	}
	print SUMMARY "\n	UND\:	";
	foreach $term (@forbidden)
	{
		print SUMMARY "$term, ";
	}
	print SUMMARY "\n	NICHT\:	";
	foreach $term (@required)
	{
		print SUMMARY "$term, ";
	}
	print SUMMARY "\nAnzahl Treffer\: $hitcount\n";
	close(SUMMARY);

	# Nun weiss der Webmaster, wonach gefragt wurde. Als naechstes kommt 
	# die Ausgabe der Suchergebnisse fuer den Besucher:

	print "Content-type: text/html\n\n";

	print "<HTML>\n<HEAD>\n<TITLE>Suchergebnisse</TITLE>\n</HEAD>\n";
	print "<body background=\"$backpicture\" bgcolor=\"\#FFFFFF\" text=\"\#808080\" link=\"\#3333CC\" vlink=\"\#666699\" alink=\"\#990099\"><font face=\"verdana, arial, helvetica\">\n";
	print "$summary";
	print "<DL>\n";

	# Unterschiedliche Ausgabe, je nachdem ob Treffer oder nicht:
	if ($hitcount > 0)
	{
		# Numerierung der Hits
		print "<ol>\n";

		# Sortierung und Ausgabe
		foreach $key (reverse sort keys %HITS)
		{
			# Dateigroesse
			$file = $HITS{$key};
			$size = -s "$basedir/$file";
			if ($size > 1500)
			{
				$size = int(10*$size/1024)/10 . " KByte";
			}
			else
			{
				$size = "$size Bytes";
			}

			# Datum der letzten Aenderung
			$last = &Last_Modified("$basedir/$file");

			# Einfuegen von Leerzeichen nach Kommata, damit die Schluesselwoerter nicht als ein langer
			# String aufgefasst werden. Anschliessend entfernen doppelter Leerzeichen.
			$keywords{$file} =~ s/,/, /g;
			$keywords{$file} =~ s/  / /g;
			
			# Ausgabe
			print "<P><li><a href=\"$baseurl$file\"><STRONG>$titles{$file}</STRONG></a> - $relevance{$file}\n";
			print "<ul type=circle>\n";
			print "  <li><i><u>Beschreibung</u>:</i> $description{$file}</li>\n";
			print "  <li><i><u>Schlsselwrter</u>:</i> $keywords{$file}</li>\n";
			print "  <li><i><u>URL</u>:</i> <CITE><A HREF=\"$baseurl$file\">$baseurl$file</A><FONT SIZE=-1>";
			print " - $size - $last</FONT></CITE></li>\n</ul>\n";
		}
		print "</ol>\n";
	}
	else
	{
		print "<blockquote>\n";
		print "  <b><p>Leider wurden keine Dokumente gefunden, die Ihrer Suchabfrage entsprachen. Sie knnen:</b></p>\n";
		print "  <ul type=circle>\n";
		print "    <li><b>sich die <a href=\"$searchhtm_url\#tips\" target=\"_self\">Abfragesyntax</a>\n";
		print "      anschauen, um Ihre Suchabfrage anders zu formulieren.</b></li>\n";
		print "      <li><b>von den <a href=\"http://www.gb-direkt.de/suche/index.htm\" target=\"_self\">anderen Navigationsmglichkeiten</a>\n";
		print "      unserer Site Gebrauch machen.</b></li>\n</ul>\n";
		print "</blockquote>\n";
	}

	# Gemeinsamer Rest:

	print "</DL>\n<p align=\"center\">\&nbsp;</p>\n";
	print "<form METHOD=\"POST\" ACTION=\"$cgi_url\">\n";
	print "<p><input TYPE=\"TEXT\" NAME=\"terms\" SIZE=\"40\"> <input TYPE=\"submit\" VALUE=\"Neue Suche\"></p>\n";
	print "</form><p>\&nbsp;</p>\n";

	print "$divideimg";

	print "<p align=\"center\"><small>Intermediate Search, Version 1.1 ist urheberrechtlich geschtzte\n";
	print "Freeware,  1997 von <a HREF=\"http://www.xav.com\" target=\"_blank\">Fluid Dynamics</a>.<br>\n";
	print "Ausfhrliche Hilfe und neueste Versionen auf der <a HREF=\"http://www.xav.com/scripts/search\" target=\"_blank\">Suchseite</a>.<br>\n";
	print "Deutsche bersetzung von <a href=\"http://www.gb-direkt.de\" target=\"_blank\">Gerold Bigorajski</a>.</small></p>\n";
	print "</font>\n</body>\n</html>\n";
}


# Datum der letzten Dateiaenderung
# Dieses wunderbare Stueckchen Code wurde von Jeff Carnahan von der 
# Firma Terminal Productions (www.terminalp.com) geschrieben.
sub Last_Modified
{
	$filename = shift;
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime((stat($filename))[9]);
	$year += 1900;
	# @months = ("Januar","Februar","Mrz","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");
	# return "$mday. $months[$mon] $year";
	@months = ("01","02","03","04","05","06","07","08","09","10","11","12");
	return "$mday.$months[$mon].$year";
}


sub bad_base
{
	print "Content-type: text/html\n\n";
	print "Das angegebene Grundverzeichnis:\n";
	print "<BLOCKQUOTE><PRE>$basedir</PRE></BLOCKQUOTE>\n";
	print "ist auf diesem Server nicht vorhanden.\n";
	exit;
}